import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.AbstractAction;
import javax.swing.JMenuItem;

import jpopup.PopupDataStore;
import jpopup.gui.MainWindow;
import jpopup.plugins.PopupPlugin;
import plugins.spamfilters.MessageContainsFilter;
import plugins.spamfilters.gui.ContainsMsgFilterWindow;


public class PopupPluginImpl implements PopupPlugin {
	private static final String name = "SPAM_FILTERS";
	
	private static final String MENU_ITEM_NAME = "Contains filter";
	
	private MainWindow mainWindow;
	private PopupDataStore popupData;

	private MessageContainsFilter mcf;
	
	public String getName() {
		return name;
	}

	public void startPlugin(MainWindow mainWindow, PopupDataStore data) {
		this.mainWindow = mainWindow;
		this.popupData = data;
				
		modifyPopupData();
		modifyGUI();
	}
	
	private void modifyPopupData() {
		mcf = new MessageContainsFilter();
		popupData.addMessageFilter(mcf.getName(), mcf);
	}
	
	private void modifyGUI() {
		JMenuItem containsMsgFilterItem = new JMenuItem(MENU_ITEM_NAME, ContainsMsgFilterWindow.getMainIcon());
		containsMsgFilterItem.setMnemonic(KeyEvent.VK_C);
		containsMsgFilterItem.addActionListener(new FilterItemAction());
		containsMsgFilterItem.setToolTipText("Message's substring filters");
		
		mainWindow.getFiltersMenu().add(containsMsgFilterItem);
	}
	
	private class FilterItemAction extends AbstractAction {

		private static final long serialVersionUID = -1255045679429514671L;

		public void actionPerformed(ActionEvent arg0) {
			ContainsMsgFilterWindow containsWindow = new ContainsMsgFilterWindow(mcf);
			
			containsWindow.pack();
			containsWindow.setVisible(true);
		}
		
	}
}
