package jpopup;

import java.io.IOException;

import javax.swing.JOptionPane;

import jpopup.gui.MainWindow;
import jpopup.plugins.PluginEngine;

/**
 * This class create main window, popup data and load plugins
 * @author Alexey Kalukin
 *
 */
public class JPopup {
	private MainWindow mainWindow;
	private PluginEngine pluginEngine;
	private PopupDataStore popupDataStore = new PopupDataStore();
	
	public void start() {
		mainWindow = new MainWindow(popupDataStore);
		connectPlugins();
	}
	
	private  void connectPlugins() {
		try {
			pluginEngine = new PluginEngine(mainWindow, popupDataStore);
			pluginEngine.getPlugins();
		} catch (IOException e) {
		//	e.printStackTrace();
			JOptionPane.showMessageDialog(mainWindow.getMainFrame(), "Some io error with plugin files.\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
		}
	}
}
