package jpopup.contact;

import jpopup.history.MessageHistory;

/**
 * This class used to store contact Node
 * @author Alexey Kalukin
 *
 */
public class Contact implements Comparable<Contact>{
	private String title = "";
	private final String UID;
	private String firstName = "";
	private String lastName = "";	
	private String Email = "";
	private String ICQ = ""; 
	private String additionalInfo = "";
	
	private MessageHistory history = null;
	
	public Contact(String UID) {
		this.title = UID;
		this.UID = UID;
	}
	
	public void setTitle(String title) {
		this.title = title;
	}
	public String getTitle() {
		return title;
	}
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}
	public String getFirstName() {
		return firstName;
	}
	public void setLastName(String lastName) {
		this.lastName = lastName;
	}
	public String getLastName() {
		return lastName;
	}
	public void setAdditionalInfo(String additionalInfo) {
		this.additionalInfo = additionalInfo;
	}
	public String getAdditionalInfo() {
		return additionalInfo;
	}

	public void setHistory(MessageHistory history) {
		this.history = history;
	}

	public MessageHistory getHistory() {
		return history;
	}

	public String getUID() {
		return UID;
	}

	public void setEmail(String email) {
		Email = email;
	}

	public String getEmail() {
		return Email;
	}

	public void setICQ(String iCQ) {
		ICQ = iCQ;
	}

	public String getICQ() {
		return ICQ;
	}
		
	public String toString() {
		return UID;
	}

	public int compareTo(Contact contact) {
		return UID.compareToIgnoreCase(contact.getUID());
	}

	
}
