package jpopup.gui.actions;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import jpopup.contact.Contact;
import jpopup.gui.MainWindow;

/**
 * This action used to add contact to contact list
 * @author Alexey Kalukin
 *
 */
public class AddContactAction extends AbstractAction {

	private static final long serialVersionUID = -2324509364841409388L;
	private static final String DESCRIPTION = "Add new user to contact list"; 
	
	private MainWindow mainWindow;
	
	public AddContactAction(MainWindow mainWindow) {
		this.mainWindow = mainWindow;
		putValue(AbstractAction.SMALL_ICON, mainWindow.getAboutIcon());
		putValue(AbstractAction.SHORT_DESCRIPTION, DESCRIPTION);
	}
	
	public void actionPerformed(ActionEvent arg0) {
		Contact newContact = new Contact(mainWindow.getAddContactString().getText().toUpperCase());
		mainWindow.addContactToContactList(newContact);
		mainWindow.getAddContactString().setText("");
	}

}
