package jpopup.gui.actions;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import jpopup.contact.Contact;
import jpopup.gui.MainWindow;

/**
 * This class used to add contact name from tab on chat tabbed pane to contact list
 * @author Alexey Kalukin
 *
 */
public class AddContactFromTabAction extends AbstractAction {

	private static final long serialVersionUID = -3698319821737549191L;
	
	private MainWindow mainWindow;
	
	public AddContactFromTabAction(MainWindow mainWindow) {
		this.mainWindow = mainWindow;
	}

	public void actionPerformed(ActionEvent arg0) {
		String contact = mainWindow.getChatTabbedPane().getTitleAt(mainWindow.getChatTabbedPane().getSelectedIndex());
		Contact newContact = new Contact(contact);
		mainWindow.addContactToContactList(newContact);
	}
}
