package jpopup.gui.actions;

import java.awt.event.ActionEvent;
import java.net.SocketException;

import javax.swing.AbstractAction;
import javax.swing.JOptionPane;

import jpopup.gui.MainWindow;
import jpopup.popupengine.LinuxPopupCatcher;
import jpopup.popupengine.PopupCatcher;
import jpopup.popupengine.text.JPopupEngine;

/**
 * This action used to cose another device for capture Winpopup messages
 * @author Alexey Kalukin
 *
 */
public class ChooseDeviceAction extends AbstractAction {
	
	private static final long serialVersionUID = 6834110777914977550L;

	private MainWindow mainFrame;
	
	public ChooseDeviceAction(MainWindow mainFrame) {
		putValue(AbstractAction.SMALL_ICON, mainFrame.getDeviceIcon());
		this.mainFrame = mainFrame;
	}
	
	public void actionPerformed(ActionEvent arg0) {
		if (mainFrame.getJPopup() != null) {
			mainFrame.getJPopup().stopListen();
		}
		
		PopupCatcher catcher = null;
		if (mainFrame.isWindows()) {						
			catcher = mainFrame.chooseEthernetDevice(true, false);
		} else {
			try {
				catcher = new LinuxPopupCatcher();
			} catch (SocketException e) {
				// e.printStackTrace();
				JOptionPane.showMessageDialog(mainFrame.getMainFrame(),
						"Can't open socket for broadcast.\n" + e, "Error",
						JOptionPane.ERROR_MESSAGE);
			}
		}
		
		if (catcher != null) {
			mainFrame.setJPopup(new JPopupEngine(catcher));
			mainFrame.getJPopup().addPopupListener(mainFrame.getMyPopupListener());
			mainFrame.getJPopup().startListen();
		}			
	}
	
}
