package jpopup.gui.actions;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import jpopup.gui.MainWindow;

/**
 * This action used to close all tabs on MainWindow
 * @author Alexey Kalukin
 *
 */
public class CloseAllTabsAction extends AbstractAction {
	private static final long serialVersionUID = 2522194981264623469L;

	private MainWindow mainWindow;
	
	public CloseAllTabsAction(MainWindow mainWindow) {
		this.mainWindow = mainWindow;
	}
	
	public void actionPerformed(ActionEvent arg0) {
		int tabCount = mainWindow.getChatTabbedPane().getTabCount();
		for (int i = 0; i < tabCount; i++) {
			String removeTabName = mainWindow.getChatTabbedPane().getTitleAt(0);
			mainWindow.removeTab(removeTabName);
		}
	}
}
