package jpopup.gui.actions;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import jpopup.gui.MainWindow;

/**
 * This action used to close all tabs in main window except current
 * @author Alexey Kalukin
 *
 */
public class CloseOthersTabsAction extends AbstractAction {
	private static final long serialVersionUID = -3782156707481491664L;

	private MainWindow mainWindow;
	
	public CloseOthersTabsAction(MainWindow mainWindow) {
		this.mainWindow = mainWindow;
	}
	
	public void actionPerformed(ActionEvent arg0) {
		int tabCount = mainWindow.getChatTabbedPane().getTabCount();
		String exceptTabName = mainWindow.getChatTabbedPane().getTitleAt(mainWindow.getChatTabbedPane()
				.getSelectedIndex());
		int currentTab = 0;
		for (int i = 0; i < tabCount; i++) {
			String removeTabName = mainWindow.getChatTabbedPane().getTitleAt(currentTab);
			if (!exceptTabName.equals(removeTabName)) {
				mainWindow.removeTab(removeTabName);
			} else {
				currentTab++;
			}
		}
	}
}
