package jpopup.gui.listeners;

import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;

import jpopup.gui.MainWindow;

/**
 * This listener used to handle clicks on links in chat window
 * @author Alexey Kalukin
 *
 */
public class ChatHyperlinkClickListener implements HyperlinkListener {

	private MainWindow mainFrame;
	public ChatHyperlinkClickListener(MainWindow mainFrame) {
		this.mainFrame = mainFrame;
	}
	public void hyperlinkUpdate(HyperlinkEvent e) {
		if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {				

			String sender = e.getDescription();

			if (mainFrame.getChatTabbedPane().indexOfTab(sender) < 0) {
				mainFrame.createNewTab(sender, mainFrame.getNoNewMSGIcon());
			}

			mainFrame.getChatTabbedPane().setSelectedIndex(mainFrame.getChatTabbedPane()
					.indexOfTab(sender));
			mainFrame.getMainFrame().setAlwaysOnTop(true);
			mainFrame.getMainFrame().setAlwaysOnTop(false);
			
		}
	}

}