package jpopup.history;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.OutputStream;

/**
 * Pseudo outputStream used to write clear history notes without XML header
 * @author Alexey Kalukin
 *
 */
public class FakeOutputStream extends OutputStream {

	private BufferedWriter writer;
	private boolean canWrite = false;
	public FakeOutputStream(BufferedWriter writer) {
		this.writer = writer;
	}
	
	public void write(int data) throws IOException {
		if (canWrite) {
			writer.write(data);
		} else if (data == (int)'>'){
			canWrite = true;
		}
	}

}
