package jpopup.history;

import java.text.DateFormat;
import java.text.ParseException;
import java.util.Date;

/**
 * This class used to store WinPopup message
 * @author Alexey Kalukin
 *
 */
public class Message {
	private static DateFormat dateFormat = DateFormat.getInstance();
	
	private String sender;
	private String text;
	private Date time;	
	
	public Message(String sender, String text) {
		this.sender = sender;
		this.text = text;
		time = new Date();
	}
	
	public Message(String sender, String text, String time) throws ParseException {
		this(sender, text);
		
		this.time = dateFormat.parse(time);
	}
	
	public Message(String sender, String text, Date time) {
		this(sender, text);
		
		this.time = time;
	}
	
	public static void setDateFormat(DateFormat df) {
		dateFormat = df;
	}
	
	public static DateFormat getDateFormat() {
		return dateFormat;
	}
	
	public void setSender(String sender) {
		this.sender = sender;
	}
	public String getSender() {
		return sender;
	}
	public void setText(String text) {
		this.text = text;
	}
	public String getText() {
		return text;
	}
	public void setTime(Date time) {
		this.time = time;
	}
	public Date getTime() {
		return time;
	}
	public String getFormatTime() {
		return dateFormat.format(time);
	}
}	
