package jpopup.history;

/**
 * Abstract history class used for create History classes for manipulating history msgs
 * @author Alexey Kalukin
 *
 */
public abstract class MessageHistory implements Iterable<Message> {
	public static final String HISTORY_DIRECTORY = "history"; 
	public static final String HISTORY_FILE_EXT = "hst";
	public static final String DEFAULT_GROUP = "*";
	public static final String DEFAULT_GROUP_RENAMER = "_";
	
	private String contactTitle;
	private String fileName;
	
	public MessageHistory(String title) {
		this.contactTitle = title;
		String newTitle = new String(title);
		if (title.equals(DEFAULT_GROUP)) {
			newTitle = DEFAULT_GROUP_RENAMER;
		}
		fileName = HISTORY_DIRECTORY + "\\" + newTitle + "." + HISTORY_FILE_EXT;
	}
	
	abstract public void addMessage(String sender, String msg, String timeStamp);
	
	abstract public void removeMessage(Message msg);

	public void setContactTitle(String contactTitle) {
		this.contactTitle = contactTitle;
	}

	public String getContactTitle() {
		return contactTitle;
	}
	
	public String getFileName() {
		return fileName;
	}
}
