package jpopup.popupengine;

import javax.swing.JOptionPane;

import net.sourceforge.jpcap.capture.CaptureDeviceOpenException;
import net.sourceforge.jpcap.capture.CapturePacketException;
import net.sourceforge.jpcap.capture.InvalidFilterException;
import net.sourceforge.jpcap.capture.PacketCapture;

public class EthernetReader implements Runnable {

	private String devicename;
	private static PacketCapture m_pcap = new PacketCapture();
	private static final String FILTER = "udp port 138";
	private RawPacketHandler handler;
	private boolean active = true;
	private int currentPacketCaptureInstance = 0;
	
	public EthernetReader(String devicename) throws CaptureDeviceOpenException {
		this.devicename = devicename;
		try {
			m_pcap.open(devicename, 1024, false, PacketCapture.DEFAULT_TIMEOUT);
			currentPacketCaptureInstance++;
			m_pcap.setFilter(FILTER, true);
			handler = new RawPacketHandler();
	        m_pcap.addRawPacketListener(handler);
		}  catch (InvalidFilterException e) {			
			// e.printStackTrace();
			JOptionPane.showMessageDialog(null,"Invalid popup message filer " + FILTER + ".\n" + e, "Error",
					JOptionPane.ERROR_MESSAGE);
		}
	}

	public void run() {
		try { 
			while (active) {
				m_pcap.capture(-1);
			}
        }catch (CapturePacketException e) {
            // e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
            JOptionPane.showMessageDialog(null,"Packet capture error.\n" + e, "Error",
					JOptionPane.ERROR_MESSAGE); 
        } 
	}
	
	public void addWinPopupDaemonListener(WinPopupDaemonListener listener) {
		handler.addWinPopupDaemonListener(listener);
	}
	
	public boolean removeWinPopupDaemonListener(WinPopupDaemonListener listener) {
		return handler.removeWinPopupDaemonListener(listener);
	}
	
	public synchronized void stop() {
		active = false;
		m_pcap.close(currentPacketCaptureInstance);
		m_pcap.endCapture();
		m_pcap.removeRawPacketListener(handler);	
		
	}
	
	public void start() {
		try {
			active = true;
			currentPacketCaptureInstance++;
			m_pcap.open(devicename, 1024, false, PacketCapture.DEFAULT_TIMEOUT);
			handler = new RawPacketHandler();
	        m_pcap.addRawPacketListener(handler);
		} catch (CaptureDeviceOpenException e) {
			// e.printStackTrace();
			JOptionPane.showMessageDialog(null,"Invalid popup message filer " + FILTER + ".\n" + e, "Error",
					JOptionPane.ERROR_MESSAGE);
		}		
	}

}
