package jpopup.popupengine;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

public abstract class PopupCatcher {
	private static final String POPUP_COMING_MSG = "Popup coming";
	
	private boolean active = true;
	
	private ArrayList<ActionListener> listeners = new ArrayList<ActionListener>();
	
	protected abstract void startCatch();	
	public abstract void stopCatch();
	
	protected void newPopupMsg(PopupMSG popupMSG) {
		if (popupMSG != null) {
			ActionEvent popupComing = new ActionEvent(popupMSG, ActionEvent.ACTION_PERFORMED ,POPUP_COMING_MSG);
			notifyListeners(popupComing);
		}
	}
	
	public void addActionListener(ActionListener listener) {
		listeners.add(listener);
	}
	
	public void removeActionListener(ActionListener listener) {
		listeners.remove(listener);
	}
	
	private void notifyListeners(ActionEvent event) {
		for (ActionListener listener: listeners) {
			listener.actionPerformed(event);
		}
	}

	public void setActive(boolean active) {
		this.active = active;
	}

	public boolean isActive() {
		return active;
	}
}
