package jpopup.popupengine;

import java.util.LinkedHashMap;

public class Protocol {
	private LinkedHashMap<String, byte[]> fields = new LinkedHashMap<String, byte[]>();
	
	public byte[] getBytes() {
		byte[] resultArray = new byte[getFieldsLength()];
		
		int counter = 0;
		for (byte[] field: getFields().values()) {	
			if (field != null) {
				for (int i = 0; i < field.length; i++) {
					resultArray[counter] = field[i];
					counter++;
				}
			}			
		}			
		
		
		return resultArray;
	}
	
	public void byteToFields(byte[] data) {
		int counter = 0;
		for (byte[] field: getFields().values()) {	
			for (int i = 0; i < field.length; i++) {
				field[i] = data[counter];
				counter++;
			}
		}
	}

	public int getFieldsLength() {
		int length = 0;
		for (byte[] field: getFields().values()) {	
			if (field != null) {
				length += field.length;
			}
		}
		
		return length;
	}
	
	protected void setFields(LinkedHashMap<String, byte[]> fields) {
		this.fields = fields;
	}

	protected LinkedHashMap<String, byte[]> getFields() {
		return fields;
	}
	
}
