package jpopup.popupengine;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;

import javax.swing.JOptionPane;

import net.sourceforge.jpcap.capture.RawPacketListener;
import net.sourceforge.jpcap.net.RawPacket;

public class RawPacketHandler implements RawPacketListener {
	private static final String MAIL_SLOT_FILTER = "\\mailslot\\messngr";

	private ArrayList<WinPopupDaemonListener> listeners = new ArrayList<WinPopupDaemonListener>();

	public void rawPacketArrived(RawPacket rawPacket) {
		byte[] packet = rawPacket.getData();
		
		try {
			String s = new String(rawPacket.getData(), PopupSMBMessage
					.getInEncoding());
			if (s.toLowerCase().indexOf(MAIL_SLOT_FILTER) == -1) {
				return;
			}
		} catch (UnsupportedEncodingException e) {
			// e.printStackTrace();
			JOptionPane.showMessageDialog(null,
					"Received message has unsupported encoding.\n" + e, "Warning",
					JOptionPane.WARNING_MESSAGE);
		}

		byte[] data = new byte[packet.length - 212];
		for (int i = 212, j = 0; i < packet.length; i++, j++) {
			data[j] = packet[i];
		}
		notifyListeners(data);

	}

	public void addWinPopupDaemonListener(WinPopupDaemonListener listener) {
		listeners.add(listener);
	}
	
	public boolean removeWinPopupDaemonListener(WinPopupDaemonListener listener) {
		return listeners.remove(listener);
	}

	private void notifyListeners(byte[] packet) {
		for (WinPopupDaemonListener listener : listeners) {
			listener.packetReady(packet);
		}
	}

}
