package jpopup.popupengine;

public class SMBMessageBlockProtocol {
	private SMBHeader smbHeader;
	private TransRequest transRequest;
	
	public SMBMessageBlockProtocol() {
		smbHeader = null;
		transRequest = null;
	}
	public SMBMessageBlockProtocol(SMBHeader smbHeader, TransRequest transRequest) {
		this.smbHeader = smbHeader;
		this.transRequest = transRequest;
	}
	
	public SMBMessageBlockProtocol(byte[] smbHeader, byte[] transRequest) {
		this(new SMBHeader(smbHeader), new TransRequest(transRequest));
	}
	
	public byte[] getBytes() {
		byte[] smbHeader = this.smbHeader.getBytes();
		byte[] transRequest = this.transRequest.getBytes();
    	byte[] resultArray = new byte[smbHeader.length + transRequest.length] ;
    	
		System.arraycopy(smbHeader, 0, resultArray, 0, smbHeader.length);
		System.arraycopy(transRequest, 0, resultArray, smbHeader.length, transRequest.length);
    	
    	return resultArray;
    }

	public void setSmbHeader(SMBHeader smbHeader) {
		this.smbHeader = smbHeader;
	}

	public SMBHeader getSmbHeader() {
		return smbHeader;
	}

	public void setTransRequest(TransRequest transRequest) {
		this.transRequest = transRequest;
	}

	public TransRequest getTransRequest() {
		return transRequest;
	}
}
