package jpopup.popupengine;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import net.sourceforge.jpcap.capture.CaptureDeviceOpenException;

public class WindowsPopupDaemon {	
	
	private EthernetReader reader;
	private ExecutorService executor;
//	private String deviceName;
	private boolean active;
//	private Thread thread;
	
	public WindowsPopupDaemon(String deviceName) throws CaptureDeviceOpenException {
//		this.deviceName = deviceName;
		reader = new EthernetReader(deviceName);
		executor = Executors.newFixedThreadPool(1);
//		thread = new Thread(reader);
	}

	public void startRead() {
		executor.execute(reader);
	//	thread.start();
		
	//	executor.notify();		
	}	

	public void setActive(boolean active) {
		this.active = active;
		
		if (active) {
	//		executor.notify();
		} else {
			executor.shutdownNow();
			reader.stop();
		}

	}
	
	public void addWinPopupDaemonListener(WinPopupDaemonListener listener) {
		reader.addWinPopupDaemonListener(listener);
	}
	
	public boolean removeWinPopupDaemonListener(WinPopupDaemonListener listener) {
		return reader.removeWinPopupDaemonListener(listener);
	}

	public boolean isActive() {
		return active;
	}
}
