package jpopup.popupengine.text;

import java.io.Serializable;

import jpopup.popupengine.PopupMSG;

/**
 * This class used to store WinPopup message in string fields
 * @author Alexey Kalukin
 *
 */
public class TextPopupMSG implements Serializable, PopupMSG {
	private static final long serialVersionUID = 2908200326074965046L;

	private static final byte[] DEFAULT_IP = new byte[]{0,0,0,0};
	
	private String sender;
	private String receiver;
	private StringBuilder text;
	private byte[] senderIP;
	
	public TextPopupMSG(String sender, String receiver, String text, byte[] senderIP) {
		this.sender = sender;
		this.receiver = receiver;
		this.text = new StringBuilder(text);
		this.senderIP = senderIP;
	}
	
	public TextPopupMSG(String sender, String receiver, String text) {
		this(sender, receiver, text, DEFAULT_IP);
	}
	
	public void setSender(String sender) {
		this.sender = sender;
	}
	public String getSender() {
		return sender;
	}
	
	public void setReceiver(String receiver) {
		this.receiver = receiver;
	}
	public String getReceiver() {
		return receiver;
	}
	
	public void setText(StringBuilder text) {
		this.text = text;
	}
	public StringBuilder getText() {
		return text;
	}
	
	public void setSenderIP(byte[] senderIP) {
		this.senderIP = senderIP;
	}
	public byte[] getSenderIP() {
		return senderIP;
	}
	
}
