package jpopup.popupengine.text;

import jpopup.popupengine.PopupCatcher;
import jpopup.popupengine.PopupSMBMessage;
import jpopup.popupengine.SMBMessageData;
import jpopup.popupengine.WinPopupDaemonListener;
import jpopup.popupengine.WindowsPopupDaemon;
import net.sourceforge.jpcap.capture.CaptureDeviceOpenException;

/**
 * This class used to catch popup messages in Microsoft Windows
 * @author Alexey Kalukin
 *
 */
public class WindowsPopupCatcher extends PopupCatcher implements WinPopupDaemonListener {
	private WindowsPopupDaemon daemon;

	public WindowsPopupCatcher(WindowsPopupDaemon daemon) throws CaptureDeviceOpenException {
		this.daemon = daemon;
		daemon.addWinPopupDaemonListener(this);		
	}
	
	
	public void setActive(boolean active) {
		super.setActive(active);
		daemon.setActive(active);
	}

	public void packetReady(byte[] packet) {
		PopupSMBMessage popupSMBMessage = new PopupSMBMessage();
		SMBMessageData msgData = new SMBMessageData(packet);
		popupSMBMessage.setData(msgData);

		TextPopupMSG popupMSG = new TextPopupMSG(popupSMBMessage
				.getSender(), popupSMBMessage.getReceiver(),
				popupSMBMessage.getText());
		
		newPopupMsg(popupMSG);
	}

	protected void startCatch() {
		daemon.startRead();
	}

	public void stopCatch() {
		daemon.removeWinPopupDaemonListener(this);	
		daemon.setActive(false);
	}
	
}
