package plugins.spamfilters;

import java.util.ArrayList;
import java.util.Iterator;

import jpopup.history.Message;
import jpopup.text.MessageFilter;

public class MessageContainsFilter implements MessageFilter, Iterable<String> {
	private static final String name = "MESSAGE_CONTAINS_FILTER";
	
	private ArrayList<String> filtersStrings = new ArrayList<String>();
	private boolean active;
	
	public boolean isValidMessage(Message message) {
		if (!active) {
			return true;
		}
		
		if (message != null) {
			String msgText = message.getText();
			for (String filter: filtersStrings) {
				if (msgText.toUpperCase().contains(filter.toUpperCase())) {
					return false;
				}
			}
		}
		return true;
	}
	
	public void addFilterString(String filterString) {
		filtersStrings.add(filterString);
	}
	
	public void setFilterAt(String filter, int index) {
		filtersStrings.set(index, filter);
	}
	
	public void removeFilterString(String filterString) {
		filtersStrings.remove(filterString);
	}

	public Iterator<String> iterator() {
		return filtersStrings.iterator();
	}

	public boolean isActive() {
		return active;
	}

	public void setActive(boolean active) {
		this.active = active;
	}

	public String getName() {
		return name;
	}

}
