package plugins.spamfilters.gui.actions;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JOptionPane;

import plugins.spamfilters.gui.ContainsMsgFilterWindow;

public class RemoveFilterAction extends AbstractAction {
	private static final long serialVersionUID = 6216256196687974732L;
	
	private static final String NAME = "Remove";
	
	private ContainsMsgFilterWindow mainFrame;
	
	public RemoveFilterAction(ContainsMsgFilterWindow mainFrame) {
		putValue(Action.NAME, NAME);
		this.mainFrame = mainFrame;
	}
	
	public void actionPerformed(ActionEvent arg0) {	
		int filterIndex = mainFrame.getFiltersList().getSelectedIndex();
		if (filterIndex > -1) {			
			int result = JOptionPane.showConfirmDialog(null
					, "Delete filter \"" 
						+ mainFrame.getFilterListModel().elementAt(filterIndex) + "\"?", "Remove filter", JOptionPane.YES_NO_OPTION);
			if (result == JOptionPane.OK_OPTION) {
				String filterString = (String)mainFrame.getFilterListModel().remove(filterIndex);
				mainFrame.getFilter().removeFilterString(filterString);				
				mainFrame.getEditFilterButton().setEnabled(false);
				mainFrame.getRemoveFilterButton().setEnabled(false);
			}
		}
	}
}