package plugins.spamfilters.gui.listeners;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JOptionPane;
import javax.xml.transform.TransformerException;

import org.xml.sax.SAXException;

import plugins.spamfilters.gui.ContainsMsgFilterWindow;

public class ContainsFilterWindowListener extends WindowAdapter {
	
	private ContainsMsgFilterWindow mainFrame;
	
	public ContainsFilterWindowListener(ContainsMsgFilterWindow mainFrame) {
		this.mainFrame = mainFrame;
	}
	
	public void windowClosing(WindowEvent e) {
		int elementsCount = mainFrame.getFilterListModel().size();
		List<String> filtList = new ArrayList<String>();
		for (int i = 0; i < elementsCount; i++) {
			filtList.add((String)mainFrame.getFilterListModel().getElementAt(i));				
		}
		
		try {
			File filterFile = new File(mainFrame.getFilterFileName());
			if (!filterFile.exists()) {
				filterFile.createNewFile();
			}
			mainFrame.getFilterManager().saveFilters(mainFrame.getFilterFileName());
		} catch (TransformerException e1) {
			JOptionPane.showMessageDialog(null,
					"Error transform xml. Can't save results to file \"" + mainFrame.getFilterFileName() + "\"\n" + e1, "Error", JOptionPane.ERROR_MESSAGE);
		//	e1.printStackTrace();
		} catch (IOException e2) {
			JOptionPane.showMessageDialog(null,
					"Error save xml. Can't save results to file \"" + mainFrame.getFilterFileName() + "\"\n" + e2, "Error", JOptionPane.ERROR_MESSAGE);
	//		e2.printStackTrace();
		}
	}

	public void windowOpened(WindowEvent e) {
		if (mainFrame.getFilterListModel().size() > 0) {
			return;
		}
		try {
			File filterFile = new File(mainFrame.getFilterFileName());
			if (!filterFile.exists()) {
				return;
			}
			List<String> filtersList = mainFrame.getFilterManager().loadFilters(mainFrame.getFilterFileName());
			for(String filter: filtersList) {
				mainFrame.getFilterListModel().addElement(filter);
				mainFrame.getFilter().addFilterString(filter);
			}
			
			if (mainFrame.getIsActiveCheckBox() != null) {
				mainFrame.getIsActiveCheckBox().setSelected(mainFrame.getFilter().isActive());
			}
		} catch (SAXException e1) {
			JOptionPane.showMessageDialog(null,
					"Error parse xml file \"" + mainFrame.getFilterFileName() + "\"\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
		//	e1.printStackTrace();
		} catch (IOException e1) {
			JOptionPane.showMessageDialog(null,
					"Error parse xml file \"" + mainFrame.getFilterFileName() + "\"\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
		//	e1.printStackTrace();
		}
	}

			
}
